#include "module.h"
#define AUTHOR "SGR"
#define VERSION "1.00"
#define DISABLE_LOWER_QAKILL

static int do_qakill_some_lameass(User * u);
int SGR_Module_Help_OPERSERV_QAKILL_FULL(User *u);
void SGR_Module_Help_OPERSERV_QAKILL(User *u);

int AnopeInit(int argc, char **argv) {
        Command *c;
        c = createCommand("QAKILL", do_qakill_some_lameass, is_services_admin,-1,-1,-1,-1,-1);
        alog("Loading module os_qakill.so [Status: %d]", moduleAddCommand(OPERSERV,c,MOD_HEAD));
	moduleAddHelp(c,SGR_Module_Help_OPERSERV_QAKILL_FULL);
        moduleSetOperHelp(SGR_Module_Help_OPERSERV_QAKILL);
        alog("[os_qakill] New command: /msg operserv QAKILL [nick] [reason]");
        alog("[os_qakill] For information see: /msg operserv HELP QAKILL");
        alog("[os_qakill] Yayness!(tm) - MODULE LOADED AND ACTIVE");
        moduleAddAuthor(AUTHOR);
        moduleAddVersion(VERSION);
        return MOD_CONT; 
}

void AnopeFini(void) {
        alog("Unloading os_qakill.so");
}

static int do_qakill_some_lameass(User * u)
{
    char *to_be_akilled, *reason;
    char reasonx[512];
    char mask[USERMAX + HOSTMAX + 2];
    User *target;

    to_be_akilled = strtok(NULL, " ");
    reason = strtok(NULL, "");

    if (!is_services_admin(u)) { 
        notice(s_OperServ, u->nick, "Accs Refus.");
	return MOD_STOP;
    }
    if (to_be_akilled) {
       if (!reason) {
           reason = "Akill by LeNa";
       }
       if (AddAkiller) {
           snprintf(reasonx, sizeof(reasonx), "[%s] %s", u->nick, reason);
       }
       if ((target = finduser(to_be_akilled))) {
            sprintf(mask, "*@%s", target->host);
            #ifdef DISABLE_LOWER_QAKILL
            if ((is_services_admin(target)) && (!is_services_root(u))) {
               notice(s_OperServ, u->nick, "Accs Refus.");
	       wallops(s_OperServ, "%s essaye de Qakill %s (%s)", u->nick, target->nick, reasonx);
               return MOD_STOP;
	    }
            #endif
            add_akill(u, mask, u->nick, time(NULL)+AutokillExpiry, reason);
            if (WallOSAkill) {
                wallops(s_OperServ, "QAKILL -> %s sur %s (%s)", u->nick, target->nick, reasonx);
            }
	    if (!AkillOnAdd) {
                kill_user(s_OperServ, target->nick, reasonx);
	    }
       }
       else {
            notice_lang(s_OperServ, u, NICK_X_NOT_IN_USE, to_be_akilled);
       }
    } 
    else {
          notice(s_OperServ, u->nick, "Syntaxe : QAKILL pseudo raison");
    }
    return MOD_CONT;
}

void SGR_Module_Help_OPERSERV_QAKILL(User *u)
{
   if (is_services_admin(u)) {
       notice(s_OperServ, u->nick, "    QAKILL      AKILL un user en fonction de son pseudo");
   }
   return;
}


int SGR_Module_Help_OPERSERV_QAKILL_FULL(User *u)
{
    if (is_services_admin(u)) {
        notice(s_OperServ, u->nick, "---------------------------------------------------------------------------------");
        notice(s_OperServ, u->nick, " Syntaxe : QAKILL pseudo raison");
	notice(s_OperServ, u->nick, "   ");
 	notice(s_OperServ, u->nick, " Cette commande sert  AKILL un user en fonction de son pseudo.");
	notice(s_OperServ, u->nick, " La raison du QAKILL est optionnelle.");
        notice(s_OperServ, u->nick, "---------------------------------------------------------------------------------");
	return MOD_CONT;
   }
   return MOD_CONT;
}


